﻿
@{
    ViewData["Title"] = "Ma sélection";

    List<Scene> listeScenes = (List<Scene>)ViewData["listeScenes"];
    List<JouerSur> listeJouerSurs = (List<JouerSur>)ViewData["listeJouerSurs"];
    List<Artiste> listeArtistes = (List<Artiste>)ViewData["listeArtistes"];
    List<Selection> listeSelections = (List<Selection>)ViewData["listeSelections"];
    //L'instruction ci dessous utilise le formalisme LINQ pour trier la liste (en fonction de l'heure de début de performance des artistes
    listeJouerSurs = (from jouerSur in listeJouerSurs orderby jouerSur.DateHeureDebutPerformance.TimeOfDay select jouerSur).ToList<JouerSur>();

    DateTime dateDeDebutFestival = (DateTime)ViewData["dateDeDebutFestival"];
    int nbrDeJours = (int)ViewData["nbrDeJoursDuFestival"];
    string artistesSelectionnes = "";
}


<div class="row mb-2">
    <div class="col-md-3 ">
        <select class="form-control" name="destinataire">
            @for (int numJour = 1; numJour <= nbrDeJours; numJour++)
            {
                <option class="journee">Jour @numJour</option>
            }
        </select>
    </div>
</div>

<div clas="row">

    <div class="col p-2">

        <div class="row">
            <!-- Affichage du jour précis -->
            @for (int numJour = 1; numJour <= nbrDeJours; numJour++)
            {
                <h6 class="col text-center p-2 intituleJournee" id="intituleJour_@numJour">@dateDeDebutFestival.AddDays(numJour - 1).ToString("dddd d MMMM")</h6>
            }
        </div>

        <div class="row p-3">

            <!-------- COLONNE JOURNEE ------------>
            <div class="col-md-5">
                <div class="row">
                    <h6 class="col mx-auto text-center">Les artistes</h6>
                </div>

                <div class="row">
                    <!-------- LISTE DES ARTISTES------------>
                    @for (int numJour = 1; numJour <= nbrDeJours; numJour++)
                    {
                        <div class="col overflow-auto border rounded pb-5" style="height: 25em" id="listeArtisteDuJour_@numJour">
                            @foreach (JouerSur jouerSur in listeJouerSurs)
                            {
                                foreach (Artiste artiste in listeArtistes)
                                {
                                    if (jouerSur.DateHeureDebutPerformance.Day == (dateDeDebutFestival.Day + numJour - 1) && jouerSur.IdArtiste == artiste.Id && !listeSelections.Exists(x => x.IdArtiste == artiste.Id))
                                    {
                                        <!-- TEMPLATE ARTISTE -->
                                        <div class="media border rounded p-2 mt-2 itemArtiste" id="itemArtiste_@artiste.Id" name="@numJour">
                                            <img src="@artiste.UrlPhoto" alt="@artiste.Nom" class="img-thumbnail mr-3 imageArtiste"
                                                 height="150" width="150">
                                            <div class="media-body">
                                                <a class="far fa-calendar-plus float-right text-dark btnAddInSelection"
                                                   href="@artiste.Id" data-toggle="modal"></a>
                                                <h6 class="mb-0 nomArtiste">@artiste.Nom</h6>
                                                <small>
                                                    <span class="paysArtiste"> @artiste.Nom</span> | <span class="styleArtiste"> @artiste.Style</span> <br>
                                                    <span class="heureDebutArtiste">@jouerSur.DateHeureDebutPerformance.ToString("H\\hmm")</span> - <span class="heureFinArtiste">@jouerSur.DateHeureFinPerformance.ToString("H\\hmm")</span> <br>
                                                    Extrait <a class="text-dark fas fa-play-circle extraitArtiste" href="@artiste.UrlExtraitMusical" target="_blank"></a>
                                                </small>
                                            </div>
                                        </div>
                                        <!-- TEMPLATE ARTISTE -->
                                    }
                                }
                            }
                        </div>
                    }
                    <!-------- LISTE DES ARTISTES ------------>
                </div>
            </div>
            <!-------- COLONNE JOURNEE ------------>
            <!-------- COLONNE MA SELECTION  ------------>
            <div class="col-md-5 offset-md-2">

                <div class="row">
                    <h6 class="col mx-auto text-center">Ma sélection</h6>
                </div>

                <!-- UNE JOURNEE SELECTION -->
                <div class="row">
                    @for (int numJour = 1; numJour <= nbrDeJours; numJour++)
                    {
                        <div class="col border rounded overflow-auto" style="height: 25em;" id="selectionFestivalierJour_@numJour">
                            @foreach (JouerSur jouerSur in listeJouerSurs)
                            {
                                foreach (Artiste artiste in listeArtistes)
                                {
                                    if (jouerSur.DateHeureDebutPerformance.Day == (dateDeDebutFestival.Day + numJour - 1) && jouerSur.IdArtiste == artiste.Id && listeSelections.Exists(x => x.IdArtiste == artiste.Id))
                                    {

                                        <!-- TEMPLATE ARTISTE -->
                                        artistesSelectionnes += "-" + artiste.Id;
                                        <div class="media border rounded p-2 mt-2 itemArtiste" id="itemArtiste_@artiste.Id" name="@numJour">
                                            <img src="@artiste.UrlPhoto" alt="@artiste.Nom" class="img-thumbnail mr-3 imageArtiste"
                                                 height="150" width="150">
                                            <div class="media-body">
                                                <a class="far fa-calendar-minus float-right text-dark btnDeleteInSelection"
                                                   href="@artiste.Id" data-toggle="modal"></a>
                                                <h6 class="mb-0 nomArtiste">@artiste.Nom</h6>
                                                <small>
                                                    <span class="paysArtiste"> @artiste.Nom</span> | <span class="styleArtiste"> @artiste.Style</span> <br>
                                                    <span class="heureDebutArtiste">@jouerSur.DateHeureDebutPerformance.ToString("H\\hmm")</span> - <span class="heureFinArtiste">@jouerSur.DateHeureFinPerformance.ToString("H\\hmm")</span> <br>
                                                    Extrait <a class="text-dark fas fa-play-circle extraitArtiste" href="@artiste.UrlExtraitMusical" target="_blank"></a>
                                                </small>
                                            </div>
                                        </div>
                                        <!-- TEMPLATE ARTISTE -->
                                    }
                                }

                            }
                        </div>
                    }


                </div>
                <!-- UNE JOURNEE SELECTION -->


                <div class="row">
                    <form class="col text-center" action="MaSelection" method="POST">
                        <input type="hidden" name="selectionFestivalier" value="@artistesSelectionnes">
                        <button type="submit" class="btn btn-outline-primary mt-2">Enregistrer</button>
                    </form>
                </div>

            </div>
            <!-------- COLONNE MA SELECTION  ------------>

        </div>

    </div>

</div>


<div class="row mt-5 mb-5">

    @{ List<JouerSur> listeJouerSursPlanning = (from jouerSur in listeJouerSurs join selection in listeSelections on jouerSur.IdArtiste equals selection.IdArtiste select jouerSur).ToList(); }

    @if (listeJouerSursPlanning.Count < 3)
    {
        <div class="col-12">
            <h6 class="text-center">Selectionnez au moins 3 artistes pour générer votre planning.</h6>
        </div>
    }
    else
    {
        int heureDebutPlanning = listeJouerSursPlanning.Min(x => x.DateHeureDebutPerformance.Hour) - 1;
        int heureFinPlanning = listeJouerSursPlanning.Max(x => x.DateHeureFinPerformance.Hour) + 2;

        Dictionary<int, string> dicoColorScene = new Dictionary<int, string>();
        String[] tabColor = { "rgba(83, 144, 240, 0.5)", "rgba(155, 188, 242, 0.5)", "rgba(82, 121, 186, 0.5)", "rgba(34, 76, 146, 0.5)" };

        for (int i = 0; i < listeScenes.Count; i++)
            dicoColorScene.Add(listeScenes[i].Id, tabColor[i]);

        double tailleCasePlanningY = 2;
        string casePlanningY = tailleCasePlanningY.ToString(new CultureInfo("en-US")) + "em";


        <div class="col-1 border">
            <div class="row" style="height: @casePlanningY;"></div>
            @for (int heure = heureDebutPlanning; heure < heureFinPlanning; heure++)
            {
                string text = "h";
                <div class="row" style="height:@casePlanningY;">
                    <div class="col text-center border-top">@heure@text</div>
                </div>
            }
        </div>

        <div class="col-11">

            <div class="row border border-left-0">

                @for (int numJour = 0; numJour < nbrDeJours; numJour++)
                {
                    <div class="col border-right">
                        <div class="row" style="height: @casePlanningY;">
                            <div class="col text-center">@dateDeDebutFestival.AddDays(numJour).ToString("dddd d MMMM")</div>
                        </div>
                        @for (int heure = heureDebutPlanning; heure < heureFinPlanning; heure++)
                        {
                            List<JouerSur> listeJouerSurDuJours = (from jouerSur in listeJouerSursPlanning where jouerSur.DateHeureDebutPerformance.Day == dateDeDebutFestival.AddDays(numJour).Day orderby jouerSur.IdScn select jouerSur).ToList();

                            <div class="row border-top" style="height: @casePlanningY;">


                                @foreach (JouerSur jouerSurAffiche in listeJouerSurDuJours.Where(x => x.DateHeureDebutPerformance.Hour == heure).OrderBy(x => x.IdScn))
                                {
                                    Artiste artisteAffiche = listeArtistes.Find(x => x.Id == jouerSurAffiche.IdArtiste);

                                    //On enregistre tous les artistes dont les plages horaires chevauchent celle de l'artiste que l'on souhait enregistrer
                                    List<JouerSur> listeTousLesJouersSurChevauchant = listeJouerSurDuJours.FindAll(
                                         x => (x.DateHeureDebutPerformance.TimeOfDay >= jouerSurAffiche.DateHeureDebutPerformance.TimeOfDay && x.DateHeureDebutPerformance.TimeOfDay <= jouerSurAffiche.DateHeureFinPerformance.TimeOfDay)
                                             || (x.DateHeureFinPerformance.TimeOfDay >= jouerSurAffiche.DateHeureDebutPerformance.TimeOfDay && x.DateHeureFinPerformance.TimeOfDay <= jouerSurAffiche.DateHeureFinPerformance.TimeOfDay)
                                             || (x.DateHeureDebutPerformance.TimeOfDay <= jouerSurAffiche.DateHeureDebutPerformance.TimeOfDay && x.DateHeureFinPerformance.TimeOfDay >= jouerSurAffiche.DateHeureFinPerformance.TimeOfDay));

                                    //On compte le nombre de chevauchement ne comptant que 1 chevauchement par scène (si 2 chevauchement mais même scène alors on ne compte que un)
                                    // on fait car besoin pour la division que 0 chevauchement vaille 1 ->(et on enlève 1 au total pour prendre en compte l'artiste a affciher qui est aussi dans la liste)
                                    int nbrDeColonnesDansMaLigne = 0;
                                    foreach (Scene scene in listeScenes)
                                    {
                                        if (listeTousLesJouersSurChevauchant.Exists(x => x.IdScn == scene.Id))
                                            nbrDeColonnesDansMaLigne++;
                                    }



                                    double a = (jouerSurAffiche.DateHeureFinPerformance.Subtract(jouerSurAffiche.DateHeureDebutPerformance).TotalMinutes / 60) * tailleCasePlanningY;
                                    double b = ((double)jouerSurAffiche.DateHeureDebutPerformance.Minute / 60) * tailleCasePlanningY;

                                    //https://docs.microsoft.com/en-us/dotnet/api/system.double.tostring?view=netcore-3.1#System_Double_ToString_System_String_
                                    string taillePlageArtiste = a.ToString(new CultureInfo("en-US")) + "em";
                                    string decalageDebutPlageArtiste = b.ToString(new CultureInfo("en-US")) + "em";

                                    int tailleColonne = 12 / nbrDeColonnesDansMaLigne;

                                    //calcul de l'offset
                                    int indexSceneAffiche = listeScenes.FindIndex(x => x.Id == jouerSurAffiche.IdScn);

                                    int nbrDeColonnesRempliesAGauche = 0;
                                    int nbrArtistesCommencantAGauche = 0;
                                    for (int i = 0; i < indexSceneAffiche; i++)
                                    {
                                        if (listeTousLesJouersSurChevauchant.Find(x => x.IdScn == listeScenes[i].Id) != null)
                                            nbrDeColonnesRempliesAGauche++;
                                        if (listeTousLesJouersSurChevauchant.Find(x => x.IdScn == listeScenes[i].Id && x.DateHeureDebutPerformance.Hour == jouerSurAffiche.DateHeureDebutPerformance.Hour) != null)
                                            nbrArtistesCommencantAGauche++;
                                    }

                                    int tailleOffset = (nbrDeColonnesRempliesAGauche - nbrArtistesCommencantAGauche) * tailleColonne;

                                    <div class="text-center col-@tailleColonne offset-@tailleOffset border rounded" style="background-color: @dicoColorScene[jouerSurAffiche.IdScn];height: @taillePlageArtiste; margin-top: @decalageDebutPlageArtiste; bac">
                                        <small>@artisteAffiche.Nom</small>
                                    </div>
                                }

                            </div>
                        }
                    </div>
                }

            </div>
        </div>

        <div class="d-flex flex-row mt-3">
            @foreach(Scene scene in listeScenes)
            {
                <div class="mx-2" style="background-color : @dicoColorScene[scene.Id]; width: 20px; height: 20px;"> </div>
                @scene.NomScene
           }
        </div>
    }

</div>



@section Scripts {

    <script type="text/javascript">


        var listeBlockArtistes = document.querySelectorAll('div[id^=listeArtisteDuJour_]');
        for (let i = 0; i < listeBlockArtistes.length; i++) {
            listeBlockArtistes[i].style.display = 'none';
        }
        document.getElementById('listeArtisteDuJour_1').style.display = 'block';

        var listeBlockSelections = document.querySelectorAll('div[id^=selectionFestivalierJour_]');
        for (let i = 0; i < listeBlockSelections.length; i++) {
            listeBlockSelections[i].style.display = 'none';
        }
        document.getElementById('selectionFestivalierJour_1').style.display = 'block';

        var listeIntituleJournees = document.querySelectorAll('.intituleJournee');
        for (let i = 0; i < listeIntituleJournees.length; i++) {
            listeIntituleJournees[i].style.display = 'none';
        }
        document.getElementById('intituleJour_1').style.display = 'block';


        var dropdown = document.querySelector('select');
        dropdown.addEventListener('change', onClickOnOptions);



        function onClickOnOptions(e) {
            var jourSelectionne = e.target.selectedIndex + 1;

            for (let i = 0; i < listeBlockArtistes.length; i++) {
                if (listeBlockArtistes[i].id == 'listeArtisteDuJour_' + jourSelectionne.toString()) {
                    listeBlockArtistes[i].style.display = 'block';
                }
                else {
                    listeBlockArtistes[i].style.display = 'none';
                }

                if (listeBlockSelections[i].id == 'selectionFestivalierJour_' + jourSelectionne.toString()) {
                    listeBlockSelections[i].style.display = 'block';
                }
                else {
                    listeBlockSelections[i].style.display = 'none';
                }

                if (listeIntituleJournees[i].id == 'intituleJour_' + jourSelectionne.toString()) {
                    listeIntituleJournees[i].style.display = 'block';
                }
                else {
                    listeIntituleJournees[i].style.display = 'none';
                }

            }

        }


        var listeItemArtistes = document.querySelectorAll('.media');


        for (let i = 0; i < listeItemArtistes.length; i++) {
            if (listeItemArtistes[i].querySelector('.btnAddInSelection') != null) {
                listeItemArtistes[i].querySelector('.btnAddInSelection').addEventListener('click', onClickInListeArtiste);
            } else {
                listeItemArtistes[i].querySelector('.btnDeleteInSelection').addEventListener('click', onClickInSelection);
            }
        }

        function onClickInListeArtiste(e) {
            var itemArtiste = document.getElementById('itemArtiste_' + e.target.getAttribute('href'));
            numJour = itemArtiste.getAttribute('name');
            var selectionFestivalier = document.getElementById('selectionFestivalierJour_' + numJour);
            selectionFestivalier.appendChild(itemArtiste);
            e.target.setAttribute('class', 'far fa-calendar-minus float-right text-dark btnDeleteInSelection')
            e.target.removeEventListener('click', onClickInListeArtiste);
            e.target.addEventListener('click', onClickInSelection);

            document.querySelector('input[name="selectionFestivalier"]').setAttribute('value', document.querySelector('input[name="selectionFestivalier"]').getAttribute('value') + "-" + e.target.getAttribute('href'))
        }


        function onClickInSelection(e) {
            var itemArtiste = document.getElementById('itemArtiste_' + e.target.getAttribute('href'));
            numJour = itemArtiste.getAttribute('name');
            var listeArtisteDuJour = document.getElementById('listeArtisteDuJour_' + numJour);
            listeArtisteDuJour.appendChild(itemArtiste);
            e.target.setAttribute('class', 'far fa-calendar-plus float-right text-dark btnAddInSelection');
            e.target.removeEventListener('click', onClickInSelection);
            e.target.addEventListener('click', onClickInListeArtiste);
            var listeDesArtistesSelectionnes = document.querySelector('input[name="selectionFestivalier"]').getAttribute('value');
            listeDesArtistesSelectionnes = listeDesArtistesSelectionnes.replace('-' + e.target.getAttribute('href'), '');
            document.querySelector('input[name="selectionFestivalier"]').setAttribute('value', listeDesArtistesSelectionnes)
        }

    </script>

}
